import { ChangeDetectorRef, NgZone, OnInit } from '@angular/core';
import { Subscription } from 'rxjs';
import GridHeadingInterface from '../../interfaces/grid-heading-type';
import GridResponseInterface from '../../interfaces/grid-response';
import GridFilterItemInterface from '../../interfaces/grid-filter-item';
import { GridService } from '../grid.service';
import GridSortItemInterface from '../../interfaces/grid-sort-item';
import * as i0 from "@angular/core";
export declare class ChildGridComponent implements OnInit {
    private changeDetectorRef;
    private gridService;
    private ngZone;
    responseEmit: any;
    buttonClickEmit: any;
    filtersChangedEmit: any;
    headings: GridHeadingInterface[];
    url: string;
    entity: any;
    loadingData: boolean;
    response: GridResponseInterface;
    responseBackup: GridResponseInterface;
    gridItems: any[];
    recordsPerPage: number;
    gridPostSubscription: Subscription;
    currentPage: number;
    serverSidePagination: boolean;
    filters: GridFilterItemInterface[];
    sortObj: GridSortItemInterface;
    selectedRows: never[];
    constructor(changeDetectorRef: ChangeDetectorRef, gridService: GridService, ngZone: NgZone);
    ngOnInit(): void;
    sort(ev: GridHeadingInterface): void;
    filter(ev: GridFilterItemInterface): void;
    openLinkInNewTab(link: string, params?: any): void;
    openExternalLinkInNewTab(link: string, params: any): void;
    goToLink(fieldName: string, item: string, click?: string): void;
    getData({ pageNo, recordsPerPage }: any): void;
    private linkCreationInterceptor;
    private sortAscending;
    pageChanged({ pageNo, recordsPerPage }: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChildGridComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChildGridComponent, "amdg-child-grid", never, { "headings": "headings"; "url": "url"; "entity": "entity"; "serverSidePagination": "serverSidePagination"; }, { "responseEmit": "responseEmit"; "buttonClickEmit": "buttonClickEmit"; "filtersChangedEmit": "filtersChangedEmit"; }, never, never, false, never>;
}
