import { AfterViewInit, ChangeDetectorRef, ElementRef, NgZone, OnChanges, OnInit, Renderer2, SimpleChanges } from '@angular/core';
import { Subscription } from 'rxjs';
import GridResponseInterface from '../../interfaces/grid-response';
import GridFilterItemInterface from '../../interfaces/grid-filter-item';
import GridSortItemInterface from '../../interfaces/grid-sort-item';
import GridHeadingInterface from '../../interfaces/grid-heading-type';
import GridMasterDetailConfigInterface from '../../interfaces/grid-master-detail-config-type';
import { CdkVirtualScrollViewport, FixedSizeVirtualScrollStrategy } from '@angular/cdk/scrolling';
import { MatLegacyDialog as MatDialog } from '@angular/material/legacy-dialog';
import { CdkDragDrop } from '@angular/cdk/drag-drop';
import { GridService } from '../grid.service';
import { GridFilterItem } from '../../angular-material-data-grid-interfaces';
import * as i0 from "@angular/core";
export declare class CustomVirtualScrollStrategy extends FixedSizeVirtualScrollStrategy {
    constructor();
}
export declare class ServerBindGridComponent implements OnInit, AfterViewInit, OnChanges {
    private changeDetectorRef;
    private renderer;
    dialog: MatDialog;
    private ngZone;
    private gridService;
    requestBodyEmit: any;
    responseEmit: any;
    selectionEmit: any;
    filtersChangedEmit: any;
    sortChangedEmit: any;
    buttonClickEmit: any;
    columnPreferencesChangedEmit: any;
    columnPreferencesChangeEndedEmit: any;
    columnPreferencesResetEmit: any;
    dataErrorEmit: any;
    headings: GridHeadingInterface[];
    url: string;
    selection: boolean;
    columnControl: boolean;
    entity: null;
    transparency: boolean;
    elevation: 0 | 1 | 2 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24;
    serverSidePagination: boolean;
    initialFilters: GridFilterItem[];
    resetFilters: null;
    expandable: boolean;
    expandableConfig: GridMasterDetailConfigInterface;
    disableFullScreenToggle: boolean;
    pageSizes: number[];
    pageSize: number;
    headingsCopy: never[];
    columnSearchParam: string;
    allGridItemsSelected: boolean;
    loadingData: boolean;
    response: GridResponseInterface;
    responseBackup: GridResponseInterface;
    gridItems: any[];
    selectionStarted: boolean;
    selectionTimeoutHandler: any;
    allCheckBoxesSelected: boolean;
    selectedRows: any[];
    gridWidth: number;
    offsetTop: number;
    scrollRemainingDistanceToLeft: number;
    scrollRemainingDistanceToRight: number;
    horizontalScrollBarWidth: number;
    currentPage: number;
    sortObj: GridSortItemInterface;
    filters: GridFilterItemInterface[];
    gridPostSubscription: Subscription;
    fullscreen: boolean;
    allRowsExpanded: boolean;
    gridContainer: ElementRef;
    cdkVirtualScrollViewport: CdkVirtualScrollViewport;
    onResize(): void;
    constructor(changeDetectorRef: ChangeDetectorRef, renderer: Renderer2, dialog: MatDialog, ngZone: NgZone, gridService: GridService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private calculateGridWidth;
    scrollLeft(): void;
    scrollRight(): void;
    scrollChanged(ev?: Event): void;
    updateColumns(columnPreferenceChangeEnded?: boolean): void;
    columnDrop(ev: CdkDragDrop<any>): void;
    sort(ev: GridHeadingInterface): void;
    filter(ev: GridFilterItemInterface): void;
    gridItemSelectionChanged(all?: boolean): void;
    startSelect(item: any, element: HTMLElement): void;
    endSelect(): void;
    overSelect($event: MouseEvent, item: any): void;
    toggleAllRowsExpansion(): void;
    clickRow($event: any, item: any, index: number): void;
    getSelection(): void;
    getData({ pageNo, recordsPerPage }: any): void;
    private sortAscending;
    pageChanged({ pageNo, recordsPerPage }: any): void;
    private linkCreationInterceptor;
    toggleFullScreen(ev: boolean): void;
    openLinkInNewTab(link: string, params?: any): void;
    openExternalLinkInNewTab(link: string, params: any): void;
    goToLink(fieldName: string, item: string, click?: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServerBindGridComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ServerBindGridComponent, "amdg-grid", never, { "headings": "headings"; "url": "url"; "selection": "selection"; "columnControl": "columnControl"; "entity": "entity"; "transparency": "transparency"; "elevation": "elevation"; "serverSidePagination": "serverSidePagination"; "initialFilters": "initialFilters"; "resetFilters": "resetFilters"; "expandable": "expandable"; "expandableConfig": "expandableConfig"; "disableFullScreenToggle": "disableFullScreenToggle"; "pageSizes": "pageSizes"; "pageSize": "pageSize"; }, { "requestBodyEmit": "requestBodyEmit"; "responseEmit": "responseEmit"; "selectionEmit": "selectionEmit"; "filtersChangedEmit": "filtersChangedEmit"; "sortChangedEmit": "sortChangedEmit"; "buttonClickEmit": "buttonClickEmit"; "columnPreferencesChangedEmit": "columnPreferencesChangedEmit"; "columnPreferencesChangeEndedEmit": "columnPreferencesChangeEndedEmit"; "columnPreferencesResetEmit": "columnPreferencesResetEmit"; "dataErrorEmit": "dataErrorEmit"; }, never, ["*"], false, never>;
}
